Package org.optaplanner.core.api.score.buildin.hardsoftlong

## Class HardSoftLongScore

- java.lang.Object
- - org.optaplanner.core.api.score.AbstractScore<HardSoftLongScore>
  - - org.optaplanner.core.api.score.buildin.hardsoftlong.HardSoftLongScore

- All Implemented Interfaces:
    `Serializable`, `Comparable<HardSoftLongScore>`, `Score<HardSoftLongScore>`

      public final class HardSoftLongScore
      extends AbstractScore<HardSoftLongScore>

  This `Score` is based on 2 levels of long constraints: hard and soft. Hard constraints have priority over soft constraints. Hard constraints determine feasibility.

  This class is immutable.

  See Also:
    `Score`, Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static HardSoftLongScore` | `ONE_HARD` |
    `static HardSoftLongScore` | `ONE_SOFT` |
    `static HardSoftLongScore` | `ZERO` |

    - ### Fields inherited from class org.optaplanner.core.api.score.AbstractScore

      `INIT_LABEL, initScore`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `HardSoftLongScore` | `add​(HardSoftLongScore addend)` | Returns a Score whose value is (this + addend).
    `int` | `compareTo​(HardSoftLongScore other)` |
    `HardSoftLongScore` | `divide​(double divisor)` | Returns a Score whose value is (this / divisor).
    `boolean` | `equals​(Object o)` |
    `long` | `getHardScore()` | The total of the broken negative hard constraints and fulfilled positive hard constraints.
    `long` | `getSoftScore()` | The total of the broken negative soft constraints and fulfilled positive soft constraints.
    `int` | `hashCode()` |
    `boolean` | `isFeasible()` | A `PlanningSolution` is feasible if it has no broken hard constraints and `Score.isSolutionInitialized()` is true.
    `HardSoftLongScore` | `multiply​(double multiplicand)` | Returns a Score whose value is (this * multiplicand).
    `HardSoftLongScore` | `negate()` | Returns a Score whose value is (- this).
    `static HardSoftLongScore` | `of​(long hardScore, long softScore)` |
    `static HardSoftLongScore` | `ofHard​(long hardScore)` |
    `static HardSoftLongScore` | `ofSoft​(long softScore)` |
    `static HardSoftLongScore` | `ofUninitialized​(int initScore, long hardScore, long softScore)` |
    `static HardSoftLongScore` | `parseScore​(String scoreString)` |
    `HardSoftLongScore` | `power​(double exponent)` | Returns a Score whose value is (this ^ exponent).
    `HardSoftLongScore` | `subtract​(HardSoftLongScore subtrahend)` | Returns a Score whose value is (this - subtrahend).
    `Number[]` | `toLevelNumbers()` | Returns an array of numbers representing the Score.
    `String` | `toShortString()` | Like `Object.toString()`, but trims score levels which have a zero weight.
    `String` | `toString()` |
    `HardSoftLongScore` | `withInitScore​(int newInitScore)` | For example `0hard/-8soft` with `-7` returns `-7init/0hard/-8soft`.

    - ### Methods inherited from class org.optaplanner.core.api.score.AbstractScore

      `buildScorePattern, buildShortString, getInitPrefix, getInitScore, isSolutionInitialized, parseInitScore, parseLevelAsBigDecimal, parseLevelAsInt, parseLevelAsLong, parseScoreTokens`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### ZERO

          public static final HardSoftLongScore ZERO

    - #### ONE_HARD

          public static final HardSoftLongScore ONE_HARD

    - #### ONE_SOFT

          public static final HardSoftLongScore ONE_SOFT

  - ### Method Detail

    - #### parseScore

          public static HardSoftLongScore parseScore​(String scoreString)

    - #### ofUninitialized

          public static HardSoftLongScore ofUninitialized​(int initScore,
                                                          long hardScore,
                                                          long softScore)

    - #### of

          public static HardSoftLongScore of​(long hardScore,
                                             long softScore)

    - #### ofHard

          public static HardSoftLongScore ofHard​(long hardScore)

    - #### ofSoft

          public static HardSoftLongScore ofSoft​(long softScore)

    - #### getHardScore

          public long getHardScore()

      The total of the broken negative hard constraints and fulfilled positive hard constraints. Their weight is included in the total. The hard score is usually a negative number because most use cases only have negative constraints.
      Returns:
        higher is better, usually negative, 0 if no hard constraints are broken/fulfilled

    - #### getSoftScore

          public long getSoftScore()

      The total of the broken negative soft constraints and fulfilled positive soft constraints. Their weight is included in the total. The soft score is usually a negative number because most use cases only have negative constraints.

      In a normal score comparison, the soft score is irrelevant if the 2 scores don't have the same hard score.

      Returns:
        higher is better, usually negative, 0 if no soft constraints are broken/fulfilled

    - #### withInitScore

          public HardSoftLongScore withInitScore​(int newInitScore)

      Description copied from interface: `Score`
      For example `0hard/-8soft` with `-7` returns `-7init/0hard/-8soft`.
      Parameters:
        `newInitScore` - always negative (except in statistical calculations), 0 if all planning variables are initialized
      Returns:
        equals score except that `Score.getInitScore()` is set to `newInitScore`

    - #### isFeasible

          public boolean isFeasible()

      Description copied from interface: `Score`
      A `PlanningSolution` is feasible if it has no broken hard constraints and `Score.isSolutionInitialized()` is true. Simple scores (`SimpleScore`, `SimpleLongScore`, `SimpleBigDecimalScore`) are always feasible, if their `Score.getInitScore()` is 0.
      Returns:
        true if the hard score is 0 or higher and the `Score.getInitScore()` is 0.

    - #### add

          public HardSoftLongScore add​(HardSoftLongScore addend)

      Description copied from interface: `Score`
      Returns a Score whose value is (this + addend).
      Parameters:
        `addend` - value to be added to this Score
      Returns:
        this + addend

    - #### subtract

          public HardSoftLongScore subtract​(HardSoftLongScore subtrahend)

      Description copied from interface: `Score`
      Returns a Score whose value is (this - subtrahend).
      Parameters:
        `subtrahend` - value to be subtracted from this Score
      Returns:
        this - subtrahend, rounded as necessary

    - #### multiply

          public HardSoftLongScore multiply​(double multiplicand)

      Description copied from interface: `Score`
      Returns a Score whose value is (this * multiplicand). When rounding is needed, it should be floored (as defined by `Math.floor(double)`).

      If the implementation has a scale/precision, then the unspecified scale/precision of the double multiplicand should have no impact on the returned scale/precision.

      Parameters:
        `multiplicand` - value to be multiplied by this Score.
      Returns:
        this * multiplicand

    - #### divide

          public HardSoftLongScore divide​(double divisor)

      Description copied from interface: `Score`
      Returns a Score whose value is (this / divisor). When rounding is needed, it should be floored (as defined by `Math.floor(double)`).

      If the implementation has a scale/precision, then the unspecified scale/precision of the double divisor should have no impact on the returned scale/precision.

      Parameters:
        `divisor` - value by which this Score is to be divided
      Returns:
        this / divisor

    - #### power

          public HardSoftLongScore power​(double exponent)

      Description copied from interface: `Score`
      Returns a Score whose value is (this ^ exponent). When rounding is needed, it should be floored (as defined by `Math.floor(double)`).

      If the implementation has a scale/precision, then the unspecified scale/precision of the double exponent should have no impact on the returned scale/precision.

      Parameters:
        `exponent` - value by which this Score is to be powered
      Returns:
        this ^ exponent

    - #### negate

          public HardSoftLongScore negate()

      Description copied from interface: `Score`
      Returns a Score whose value is (- this).
      Returns:
        - this

    - #### toLevelNumbers

          public Number[] toLevelNumbers()

      Description copied from interface: `Score`
      Returns an array of numbers representing the Score. Each number represents 1 score level. A greater score level uses a lower array index than a lesser score level.

      When rounding is needed, each rounding should be floored (as defined by `Math.floor(double)`). The length of the returned array must be stable for a specific `Score` implementation.

      For example: `-0hard/-7soft` returns `new int{-0, -7}`

      The level numbers do not contain the `Score.getInitScore()`. For example: `-3init/-0hard/-7soft` also returns `new int{-0, -7}`

      Returns:
        never null
      See Also:
        `ScoreDefinition.fromLevelNumbers(int, Number[])`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### compareTo

          public int compareTo​(HardSoftLongScore other)

    - #### toShortString

          public String toShortString()

      Description copied from interface: `Score`
      Like `Object.toString()`, but trims score levels which have a zero weight. For example 0hard/-258soft returns -258soft.

      Do not use this format to persist information as text, use `Object.toString()` instead, so it can be parsed reliably.

      Returns:
        never null

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`